package com.lqkj.link.module.zone.repository;

import com.lqkj.link.module.zone.domain.GeomInfo;
import com.lqkj.link.module.zone.domain.TmpGeomInfo;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

@Repository
public interface TmpGeomInfoRepository extends JpaRepository<TmpGeomInfo, Integer> {

    @Query(nativeQuery = true,
        value = "with t1 as(select zone_id, st_makepoint(" +
                    "(init_location -> 'translation' ->> 'x')\\:\\:float8, " +
                    "(init_location -> 'translation' ->> 'y')\\:\\:float8, " +
                    "(init_location -> 'translation' ->> 'z')\\:\\:float8) as init from zone_info where zone_id = :zoneId) " +
                "select gi.* from geom_info gi, t1 where gi.zone_id = t1.zone_id order by st_distance(gi.geom, t1.init) "
    )
    List<GeomInfo> findAllByZoneId(Integer zoneId);


    @Query(nativeQuery = true,
        value = "select * from tmp_geom_info where zone_id = :zoneId and status = :status and " +
                "(:userId = 0 or user_id = :userId) group by user_id,tmp_id order by create_time desc "
    )
    List<TmpGeomInfo> findAllByParam(Integer zoneId, Integer userId, Integer status);
}
